﻿using System.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Docking;

namespace WPF_Docking
{
    public static class AutoHideAreaBehavior
    {
        public static bool GetIsAutoHideArea(DependencyObject obj)
        {
            return (bool)obj.GetValue(IsAutoHideAreaProperty);
        }

        public static void SetIsAutoHideArea(DependencyObject obj, bool value)
        {
            obj.SetValue(IsAutoHideAreaProperty, value);
        }

        public static readonly DependencyProperty IsAutoHideAreaProperty =
            DependencyProperty.RegisterAttached("IsAutoHideArea", typeof(bool), typeof(AutoHideAreaBehavior), new PropertyMetadata(OnIsAutoHideAreaChanged));

        private static void OnIsAutoHideAreaChanged(DependencyObject sender, DependencyPropertyChangedEventArgs args)
        {
            var notifyLayoutChange = sender as INotifyLayoutChange;
            notifyLayoutChange.LayoutChangeStarted += notifyLayoutChange_LayoutChangeStarted;
        }

        private static void notifyLayoutChange_LayoutChangeStarted(object sender, System.EventArgs e)
        {
            var area = sender as AutoHideArea;
            if (area.Items.Count > 0)
            {
                // You could load the pane's content here.
            }
        }
    }
}